Index: /palm/trunk/UTIL/inifor/src/grid.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/grid.f90	(revision 3394)
+++ /palm/trunk/UTIL/inifor/src/grid.f90	(revision 3395)
@@ -2711,9 +2991,141 @@
           input_id          = 1,                                               &
           output_file       = output_file,                                     &
-          grid              = scalar_profile_grid,                             &
-          intermediate_grid = scalar_profile_intermediate                      &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
        )
        output_var_table(55) % to_be_processed = ls_forcing_variables_required
 
+
+       output_var_table(56) = init_nc_var(                                     &
+          name              = 'internal_density_centre',                              &
+          std_name          = "",                                              &
+          long_name         = "",                                              &
+          units             = "",                                              &
+          kind              = "internal profile",                              &
+          input_id          = 4,                                               &
+          output_file       = output_file,                                     &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
+       )
+       output_var_table(56) % averaging_grid => averaged_scalar_profile
+
+
+       output_var_table(57) = init_nc_var(                                     &
+          name              = 'internal_density_north',                       &
+          std_name          = "",                                              &
+          long_name         = "",                                              &
+          units             = "",                                              &
+          kind              = "internal profile",                              &
+          input_id          = 4,                                               &
+          output_file       = output_file,                                     &
+          grid              = north_averaged_scalar_profile,                   &
+          intermediate_grid = north_averaged_scalar_profile                    &
+       )
+       output_var_table(57) % averaging_grid => north_averaged_scalar_profile
+       output_var_table(57) % to_be_processed = .NOT. cfg % ug_is_set
+
+
+       output_var_table(58) = init_nc_var(                                     &
+          name              = 'internal_density_south',                       &
+          std_name          = "",                                              &
+          long_name         = "",                                              &
+          units             = "",                                              &
+          kind              = "internal profile",                              &
+          input_id          = 4,                                               &
+          output_file       = output_file,                                     &
+          grid              = south_averaged_scalar_profile,                   &
+          intermediate_grid = south_averaged_scalar_profile                    &
+       )
+       output_var_table(58) % averaging_grid => south_averaged_scalar_profile
+       output_var_table(58) % to_be_processed = .NOT. cfg % ug_is_set
+
+
+       output_var_table(59) = init_nc_var(                                     &
+          name              = 'internal_density_east',                        &
+          std_name          = "",                                              &
+          long_name         = "",                                              &
+          units             = "",                                              &
+          kind              = "internal profile",                              &
+          input_id          = 4,                                               &
+          output_file       = output_file,                                     &
+          grid              = east_averaged_scalar_profile,                    &
+          intermediate_grid = east_averaged_scalar_profile                     &
+       )
+       output_var_table(59) % averaging_grid => east_averaged_scalar_profile
+       output_var_table(59) % to_be_processed = .NOT. cfg % ug_is_set
+
+
+       output_var_table(60) = init_nc_var(                                     &
+          name              = 'internal_density_west',                        &
+          std_name          = "",                                              &
+          long_name         = "",                                              &
+          units             = "",                                              &
+          kind              = "internal profile",                              &
+          input_id          = 4,                                               &
+          output_file       = output_file,                                     &
+          grid              = west_averaged_scalar_profile,                    &
+          intermediate_grid = west_averaged_scalar_profile                     &
+       )
+       output_var_table(60) % averaging_grid => west_averaged_scalar_profile
+       output_var_table(60) % to_be_processed = .NOT. cfg % ug_is_set
+
+       output_var_table(61) = init_nc_var(                                     &
+          name              = 'internal_pressure_north',                       &
+          std_name          = "",                                              &
+          long_name         = "",                                              &
+          units             = "",                                              &
+          kind              = "internal profile",                              &
+          input_id          = 2,                                               &
+          output_file       = output_file,                                     &
+          grid              = north_averaged_scalar_profile,                   &
+          intermediate_grid = north_averaged_scalar_profile                    &
+       )
+       output_var_table(61) % averaging_grid => north_averaged_scalar_profile
+       output_var_table(61) % to_be_processed = .NOT. cfg % ug_is_set
+
+
+       output_var_table(62) = init_nc_var(                                     &
+          name              = 'internal_pressure_south',                       &
+          std_name          = "",                                              &
+          long_name         = "",                                              &
+          units             = "",                                              &
+          kind              = "internal profile",                              &
+          input_id          = 2,                                               &
+          output_file       = output_file,                                     &
+          grid              = south_averaged_scalar_profile,                   &
+          intermediate_grid = south_averaged_scalar_profile                    &
+       )
+       output_var_table(62) % averaging_grid => south_averaged_scalar_profile
+       output_var_table(62) % to_be_processed = .NOT. cfg % ug_is_set
+
+
+       output_var_table(63) = init_nc_var(                                     &
+          name              = 'internal_pressure_east',                        &
+          std_name          = "",                                              &
+          long_name         = "",                                              &
+          units             = "",                                              &
+          kind              = "internal profile",                              &
+          input_id          = 2,                                               &
+          output_file       = output_file,                                     &
+          grid              = east_averaged_scalar_profile,                    &
+          intermediate_grid = east_averaged_scalar_profile                     &
+       )
+       output_var_table(63) % averaging_grid => east_averaged_scalar_profile
+       output_var_table(63) % to_be_processed = .NOT. cfg % ug_is_set
+
+
+       output_var_table(64) = init_nc_var(                                     &
+          name              = 'internal_pressure_west',                        &
+          std_name          = "",                                              &
+          long_name         = "",                                              &
+          units             = "",                                              &
+          kind              = "internal profile",                              &
+          input_id          = 2,                                               &
+          output_file       = output_file,                                     &
+          grid              = west_averaged_scalar_profile,                    &
+          intermediate_grid = west_averaged_scalar_profile                     &
+       )
+       output_var_table(64) % averaging_grid => west_averaged_scalar_profile
+       output_var_table(64) % to_be_processed = .NOT. cfg % ug_is_set
 
        ! Attributes shared among all variables
@@ -2732,6 +3144,6 @@
 !------------------------------------------------------------------------------!
     FUNCTION init_nc_var(name, std_name, long_name, units, kind, input_id,     &
-                         grid, intermediate_grid, output_file, is_profile      &
-             ) RESULT(var)
+                         grid, intermediate_grid, output_file, is_profile)     &
+       RESULT(var)
 
        CHARACTER(LEN=*), INTENT(IN)      ::  name, std_name, long_name, units, kind
@@ -2772,4 +3184,5 @@
           var % dimvarids(1:3)  = output_file % dimvarids_soil
           var % to_be_processed = init_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_2d"
 
@@ -2781,4 +3194,5 @@
           var % dimvarids(1:3)  = output_file % dimvarids_scl
           var % to_be_processed = init_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2794,4 +3208,5 @@
           var % dimvarids(3)    = output_file % dimvarids_scl(3)
           var % to_be_processed = init_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2807,4 +3222,5 @@
           var % dimvarids(3)    = output_file % dimvarids_scl(3)
           var % to_be_processed = init_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2820,4 +3236,5 @@
           var % dimvarids(3)    = output_file % dimvarids_vel(3)
           var % to_be_processed = init_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2829,4 +3246,5 @@
           var % dimvarids(1)    = output_file % dimvarids_scl(3) !z
           var % to_be_processed = init_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "average profile"
 
@@ -2838,4 +3256,5 @@
           var % dimvarids(1)    = output_file % dimvarids_vel(3) !z
           var % to_be_processed = init_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "average profile"
 
@@ -2848,4 +3267,5 @@
           var % dimvarids(1:2)  = output_file % dimvarids_soil(1:2)
           var % to_be_processed = boundary_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_2d"
 
@@ -2860,4 +3280,5 @@
           var % dimvarids(2)    = output_file % dimvarids_scl(3)
           var % to_be_processed = boundary_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2872,4 +3293,5 @@
           var % dimvarids(2)    = output_file % dimvarids_scl(3)
           var % to_be_processed = boundary_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2884,4 +3306,5 @@
           var % dimvarids(2)    = output_file % dimvarids_scl(2)
           var % to_be_processed = boundary_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2896,4 +3319,5 @@
           var % dimvarids(2)    = output_file % dimvarids_scl(3)
           var % to_be_processed = boundary_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2908,4 +3332,5 @@
           var % dimvarids(2)    = output_file % dimvarids_scl(3)
           var % to_be_processed = boundary_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2920,4 +3345,5 @@
           var % dimvarids(2)    = output_file % dimvarids_scl(2)
           var % to_be_processed = boundary_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2932,4 +3358,5 @@
           var % dimvarids(2)    = output_file % dimvarids_scl(3)
           var % to_be_processed = boundary_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2944,4 +3371,5 @@
           var % dimvarids(2)    = output_file % dimvarids_scl(3)
           var % to_be_processed = boundary_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2956,4 +3384,5 @@
           var % dimvarids(2)    = output_file % dimvarids_vel(2)
           var % to_be_processed = boundary_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2968,4 +3397,5 @@
           var % dimvarids(2)    = output_file % dimvarids_vel(3)
           var % to_be_processed = boundary_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2980,4 +3410,5 @@
           var % dimvarids(2)    = output_file % dimvarids_vel(3)
           var % to_be_processed = boundary_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "interpolate_3d"
 
@@ -2988,5 +3419,6 @@
           var % dimvarids(1)    = output_file % dimvarid_time
           var % to_be_processed = .TRUE.
-          var % task            = "average scalar"
+          var % is_internal     = .FALSE.
+          var % task            = "average profile"
 
        CASE( 'constant scalar profile' )
@@ -2998,4 +3430,5 @@
           var % dimvarids(1)    = output_file % dimvarids_scl(3)
           var % to_be_processed = .TRUE.
+          var % is_internal     = .FALSE.
           var % task            = "set profile"
 
@@ -3008,5 +3441,17 @@
           var % dimvarids(1)    = output_file % dimvarids_scl(3)
           var % to_be_processed = ls_forcing_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "average large-scale profile"
+
+       CASE( 'geostrophic' )
+          var % lod             = -1
+          var % ndim            = 2
+          var % dimids(2)       = output_file % dimid_time    !t
+          var % dimids(1)       = output_file % dimids_scl(3) !z
+          var % dimvarids(2)    = output_file % dimvarid_time
+          var % dimvarids(1)    = output_file % dimvarids_scl(3)
+          var % to_be_processed = .TRUE.
+          var % is_internal     = .FALSE.
+          var % task            = "geostrophic winds"
 
        CASE( 'large-scale w forcing' )
@@ -3018,5 +3463,17 @@
           var % dimvarids(1)    = output_file % dimvarids_vel(3)
           var % to_be_processed = ls_forcing_variables_required
+          var % is_internal     = .FALSE.
           var % task            = "average large-scale profile"
+
+       CASE( 'internal profile' )
+          var % lod             = -1
+          var % ndim            = 2
+          var % dimids(2)       = output_file % dimid_time    !t
+          var % dimids(1)       = output_file % dimids_scl(3) !z
+          var % dimvarids(2)    = output_file % dimvarid_time
+          var % dimvarids(1)    = output_file % dimvarids_scl(3)
+          var % to_be_processed = .TRUE.
+          var % is_internal     = .TRUE.
+          var % task            = "internal profile"
 
        CASE DEFAULT
@@ -3031,5 +3488,5 @@
     SUBROUTINE fini_variables()
 
-       CALL report('fini_variables', 'Deallocating variable table')
+       CALL report('fini_variables', 'Deallocating variable table', cfg % debug)
        DEALLOCATE( input_var_table )
 
@@ -3039,5 +3496,5 @@
     SUBROUTINE fini_io_groups()
 
-       CALL report('fini_io_groups', 'Deallocating IO groups')
+       CALL report('fini_io_groups', 'Deallocating IO groups', cfg % debug)
        DEALLOCATE( io_group_list )
 
@@ -3047,5 +3504,5 @@
     SUBROUTINE fini_file_lists()
        
-       CALL report('fini_file_lists', 'Deallocating file lists')
+       CALL report('fini_file_lists', 'Deallocating file lists', cfg % debug)
        DEALLOCATE( flow_files, soil_files, radiation_files, soil_moisture_files )
 
@@ -3134,6 +3591,6 @@
              ! rotated velocities
              DO k = 1, nz
-             DO j = 2, ny
-             DO i = 2, nx
+             DO j = 1, ny
+             DO i = 1, nx
                 CALL uv2uvrot( urot = preprocess_buffer(1) % array(i,j,k),     &
                                vrot = preprocess_buffer(2) % array(i,j,k),     &
@@ -3171,5 +3628,5 @@
           CALL report('preprocess', message)
        
-       CASE( 'temperature' ) ! P and T
+       CASE( 'thermodynamics' ) ! T, P, QV
           nx = SIZE(input_buffer(1) % array, 1)
           ny = SIZE(input_buffer(1) % array, 2)
@@ -3192,5 +3649,6 @@
 
                 input_buffer (2) % array(i,j,:) =                              &
-                   input_buffer (2) % array(i,j,:) + basic_state_pressure(:)
+                   HECTO * input_buffer (2) % array(i,j,:) +                   &
+                   basic_state_pressure(:)
 
              END DO
@@ -3204,10 +3662,42 @@
 
           END IF
+          ! pressure
+          input_buffer(2) % is_preprocessed = .TRUE.
+
+          ! Copy temperature to last input buffer array
+          ALLOCATE(                                                            &
+              input_buffer( group % n_output_quantities ) % array (nx, ny, nz) &
+          )
+          input_buffer(group % n_output_quantities) % array(:,:,:) =           &
+              input_buffer(1) % array(:,:,:)
 
           ! Convert absolute to potential temperature
-          input_buffer(1) % array(:,:,:) = input_buffer(1) % array(:,:,:) *    &
-             EXP( RD_PALM/CP_PALM * LOG( P_REF / input_buffer(2) % array(:,:,:) ))
-
-          input_buffer(1:2) % is_preprocessed = .TRUE.
+          CALL potential_temperature(                                          &
+             t = input_buffer(1) % array(:,:,:),                               &
+             p = input_buffer(2) % array(:,:,:),                               &
+             p_ref = P_REF,                                                    &
+             r = RD_PALM,                                                      &
+             cp = CP_PALM                                                      &
+          )
+
+          ! potential temperature
+          input_buffer(1) % is_preprocessed = .TRUE.
+
+          ! Convert temperature copy to density
+          CALL moist_density(                                                  &
+             t_rho = input_buffer(group % n_output_quantities) % array(:,:,:), &
+             p = input_buffer(2) % array(:,:,:),                               &
+             qv = input_buffer(3) % array(:,:,:),                              &
+             rd = RD,                                                          &
+             rv = RV                                                           &
+          )
+
+          ! qv
+          input_buffer(3) % is_preprocessed = .TRUE.
+
+          ! density
+          input_buffer(group % n_output_quantities) % is_preprocessed = .TRUE.
+
+
           message = "Input buffers for group '" // TRIM(group % kind) // "'"//&
              " preprocessed sucessfully."
@@ -3336,5 +3826,5 @@
 
        CASE DEFAULT
-          message = "Buffer kind '" // TRIM(group % kind) // "' is not supported."
+          message = "IO group kind '" // TRIM(group % kind) // "' is not supported."
           CALL abort('prerpocess', message)
 
